#Credit: Yousif Almamalachy

#Email: yousif_samir@yahoo.com

#..........................................................
import arcpy,os,sys,fnmatch,shutil,time
from arcpy.sa import *
arcpy.env.overwriteOutput = True
infold=arcpy.GetParameterAsText(0)
#infold=r'D:\stitching tool test data\LC08_L1TP_165039_20170902_20170916_01_T1'
nodata=arcpy.GetParameterAsText(1)
outfold=arcpy.GetParameterAsText(2)

#Read Band 10 and Band 11
arcpy.env.workspace = infold
rasters = arcpy.ListRasters('*', "TIF")
strr='Nullfree'
for line in rasters:
        if line.find(strr)!=-1:
                arcpy.Delete_management(line)
                        
name=[]
strr=['B4','B5','B10','B11']
for stre in strr:
        for line in rasters:
                if line.find(stre)!=-1:
                        name.append(line)
                        
                                
        
removelist=[]                   
name1=[]
if nodata:               
        for band in name:    
                 outSetNull = SetNull(band, band, "VALUE = " + str(nodata))
                 outSetNull.save(os.path.join(infold,band[:-4]+"-Nullfree.tif"))
                 name1.append(band[:-4]+"-Nullfree.tif")
        removelist=name1     
        B4=name1[0];B5=name1[1];B10=name1[2];B11=name1[3]
else:
    B4=name[0];B5=name[1];B10=name[2];B11=name[3]    
#Read constants from metadata
MetaDataFileName=os.path.join(infold,name[0][:-7]+"_MTL.txt")
metadata = open(MetaDataFileName,"r")
metadata=metadata.readlines()
varss=['RADIANCE_MULT_BAND_10','RADIANCE_MULT_BAND_11','RADIANCE_ADD_BAND_10','RADIANCE_ADD_BAND_11','K1_CONSTANT_BAND_10','K1_CONSTANT_BAND_11','K2_CONSTANT_BAND_10','K2_CONSTANT_BAND_11']
g=0;ML=[];AL=[];K1=[];K2=[]
for var in varss:
        for line in metadata:
            if line.find(var)!=-1:
                x=line
                xx=float(x[x.find('=')+2:-1])
                if g==0:
                        ML.append(xx)
                        
                elif g==1:
                        ML.append(xx)
                        
                elif g==2:
                        AL.append(xx)
                          
                elif g==3:
                        AL.append(xx)
                        
                elif g==4:
                        K1.append(xx)

                elif g==5:
                        K1.append(xx)
                        
                elif g==6:
                        K2.append(xx)
                        
                elif g==7:
                        K2.append(xx)
        g+=1
        
#Calculate NDVI     
out=os.path.join(infold,"NDVI.tif");removelist.append("NDVI.tif")
arcpy.gp.RasterCalculator_sa('Float ('"'"+B5+"'"'- '"'"+B4+"'"') / Float ('"'"+B5+"'"' + '"'"+B4+"'"')', out)

#Implement equations through band 10 and 11
bands= [B10,B11]
g=0
for band in bands:
        out=os.path.join(infold,"L.tif");removelist.append("L.tif")
        arcpy.gp.RasterCalculator_sa('('+str(ML[g])+' * '"'"+band+"'"') + '+str(AL[g])+'',out) # Calculate band radiance
        out=os.path.join(infold,"T.tif");removelist.append("T.tif")
        arcpy.gp.RasterCalculator_sa('('+str(K2[g])+' / Ln(('+str(K1[g])+' / "L.tif") + '+str(1)+'))-'+str(273.15)+'', out) # Calculate band top of atmosphere brightness temperature
        
        NDVImin=str(arcpy.GetRasterProperties_management("NDVI.tif", "MINIMUM"))
        NDVImax=str(arcpy.GetRasterProperties_management("NDVI.tif", "MAXIMUM"))
        out=os.path.join(infold,"Roh.tif");removelist.append("Roh.tif")
        arcpy.gp.RasterCalculator_sa('Square(Float ("NDVI.tif" - '+NDVImin+') / Float ('+NDVImax+' - '+NDVImin+'))', out) #Calculate Roh
        out=os.path.join(infold,"Epsilon.tif");removelist.append("Epsilon.tif")
        arcpy.gp.RasterCalculator_sa('"Roh.tif" * '+str(0.004)+' + '+str(0.986)+'', out) #Calculate Epsilon
        if g==0:
                out=os.path.join(infold,"LST10.tif");removelist.append("LST10.tif")
                arcpy.gp.RasterCalculator_sa('("T.tif" / ('+str(1)+' + ((('+str(10.895)+' * "T.tif") / '+str(14388)+') * Ln("Epsilon.tif"))))', out) #Calculate LST
        elif g==1:
                out=os.path.join(infold,"LST11.tif");removelist.append("LST11.tif")
                arcpy.gp.RasterCalculator_sa('("T.tif" / ('+str(1)+' + ((('+str(12)+' * "T.tif") / '+str(14388)+') * Ln("Epsilon.tif"))))', out) #Calculate LST
        g+=1
        
out=os.path.join(outfold)
Average=CellStatistics(["LST10.tif", "LST11.tif"], "MEAN", "DATA")
Average.save(out)

                
#Delete intermediate unneeded data
for file in removelist:
    arcpy.Delete_management(file)
    
arcpy.AddWarning("\n" + "All done!" + "\n" + "Thank you for using L8 LST tool" + "\n" + "Credit: Yousif Almamalachy" + "\n" + "Email: yousif_samir@yahoo.com")    
time.sleep(7)